/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2022 Loongson Technology Corporation Limited
 */

#ifndef __L3FWD_EM_HLM_MIPS_H__
#define __L3FWD_EM_HLM_MIPS_H__

#include "l3fwd_mips.h"
#ifdef RTE_ARCH_NO_VECTOR
static __rte_always_inline void
get_ipv4_5tuple(struct rte_mbuf *m0, xmm_t mask0,
		union ipv4_5tuple_host *key)
{
	xmm_t tmpdata0;
	tmpdata0 = *(xmm_t *)
			rte_pktmbuf_mtod_offset(m0, xmm_t *,
				sizeof(struct ether_hdr) +
				offsetof(struct ipv4_hdr, time_to_live));
	key->xmm.u64[0] = tmpdata0.u64[0] & mask0.u64[0];
	key->xmm.u64[1] = tmpdata0.u64[1] & mask0.u64[1];
}

static inline void
get_ipv6_5tuple(struct rte_mbuf *m0, xmm_t mask0,
		xmm_t mask1, union ipv6_5tuple_host *key)
{
	xmm_t tmpdata0, tmpdata1, tmpdata2;
	tmpdata0 = *(xmm_t *)
			rte_pktmbuf_mtod_offset(m0, xmm_t *,
				sizeof(struct ether_hdr) +
				offsetof(struct ipv6_hdr, payload_len));

	tmpdata1 = *(xmm_t *)
			rte_pktmbuf_mtod_offset(m0, xmm_t *,
				sizeof(struct ether_hdr) +
				offsetof(struct ipv6_hdr, payload_len) +
				sizeof(xmm_t));

	tmpdata2 = *(xmm_t *)
			rte_pktmbuf_mtod_offset(m0, xmm_t *,
				sizeof(struct ether_hdr) +
				offsetof(struct ipv6_hdr, payload_len) +
				sizeof(xmm_t) + sizeof(xmm_t));

	key->xmm[0].u64[0] = tmpdata0.u64[0] & mask0.u64[0];
	key->xmm[0].u64[1] = tmpdata0.u64[1] & mask0.u64[1];
	key->xmm[1] = tmpdata1;
	key->xmm[2].u64[0] = tmpdata2.u64[0] & mask1.u64[0];
	key->xmm[2].u64[1] = tmpdata2.u64[1] & mask1.u64[1];
}

#else
#endif
#endif /* __L3FWD_EM_MIPS_HLM_H__ */
